/*
 * SPDX-FileCopyrightText: 2019 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#pragma once

#include "slist.h"
#include "types.h"

typedef struct _HashTable HashTable;


HashTable *  hash_table_new     (HashFunc      hash_func,
                                 EqualFunc     equal_func,
                                 FreeFunc      free_key_func,
                                 FreeFunc      free_value_func);
void         hash_table_free    (HashTable    *self);

void         hash_table_insert  (HashTable  *table,
                                 const void *key,
                                 const void *value);
const void * hash_table_lookup  (HashTable  *self,
                                 const void *key);

void         hash_table_foreach (HashTable   *self,
                                 HashIterFunc func,
                                 void        *user_data);
