/*
 * SPDX-FileCopyrightText: 2019-2020 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#pragma once

#include "macros.h"
#include "types.h"

typedef struct _SList SList;
struct _SList
{
  void  *data;
  SList *next;
};

SList * slist_prepend (SList      *list,
                       void       *data) ATTR_WARN_UNUSED_RESULT;

SList * slist_find    (SList      *slist,
                       const void *data);
SList * slist_nth     (SList      *slist,
                       int         index);
void    slist_foreach (SList      *list,
                       ForEachFunc func,
                       void       *user_data);

SList * slist_remove   (SList   *list,
                        void    *data,
                        FreeFunc func) ATTR_WARN_UNUSED_RESULT;
void    slist_free_all (SList   *list,
                        FreeFunc func);
