/*
 * SPDX-FileCopyrightText: 2019 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#pragma once

#include <stdbool.h>

typedef void   (*FreeFunc)    (void       *data);
typedef void   (*ForEachFunc) (void       *data,
                               void       *user_data);
typedef double (*ValueFunc)   (const void *element);
typedef int    (*CompareFunc) (const void *a,
                               const void *b);
typedef bool   (*EqualFunc)   (const void *a,
                               const void *b);

typedef unsigned (*HashFunc)     (const void *key);
typedef void     (*HashIterFunc) (void       *key,
                                  void       *value,
                                  void       *user_data);
